class Generator {
  constructor(matcher, action) {
    this.matcher = matcher;
    this.action = action;
  }

  toString() {
    return `Generator(${this.matcher}, ${this.action})`
  }

  matches(context) {
    try {
      return this.matcher(context)
    } catch ( e ) { 
      // don't care
    }
  }

  apply(generators, context) {
    const value = this.action(generators, context)
    return value
  }
}

class Generators {
  constructor(generators) {
    this.generators = generators
    this.logs = []
  };

  apply(contexts) {
    if (Array.isArray(contexts)) {
    } else if ( typeof contexts == 'object' ) {
      contexts = [contexts]
    } else {
      return String(contexts)
    }
    
    const contexts_prime = [];
    for (const icontext in contexts) {
      const context = contexts[icontext]
      let context_prime = JSON.stringify(context);
      for (let igenerator = 0; igenerator < this.generators.length; ++igenerator) {
        const generator = this.generators[igenerator];
        if (generator.matches(context)) {
          const g = (context) => { 
            const value = this.apply(context) 
            return value
          }
          this.logs.push(`Generators: applied ${generator.toString()}\n to\n ${JSON.stringify(context)}`)
          context_prime = generator.apply(g, context);
          break
        }
      }
      contexts_prime.push(context_prime);
    }
    return contexts_prime;
  }
}

module.exports = { Generator, Generators};
